<html><head><title>TRANE-COMMON</title></head><body><h3>API for package TRANE-COMMON</h3>
<blockquote>UNDOCUMENTED</blockquote>
<p><b>*config*</b>&nbsp;&nbsp;&nbsp;<i>variable</i></p>
<blockquote>Parsed configuration file.</blockquote>
<blockquote>Initial value: <tt>#S(PY-CONFIGPARSER:CONFIG :DEFAULTS #S(PY-CONFIGPARSER::SECTION :NAME "DEFAULT" :OPTIONS NIL) :SECTIONS NIL :OPTION-NAME-TRANSFORM-FN #<Compiled-function STRING-DOWNCASE #x30004037C60F> :SECTION-NAME-TRANSFORM-FN #<Compiled-function IDENTITY #x3000400DF02F>)</tt></blockquote>
<p><b>*db*</b>&nbsp;&nbsp;&nbsp;<i>variable</i></p>
<blockquote>Database connection specification</blockquote>
<blockquote>Initial value: <tt>NIL</tt></blockquote>
<p><b>*error-context-hook*</b>&nbsp;&nbsp;&nbsp;<i>variable</i></p>
<blockquote>When set to a function designator, designated function will be
  FUNCALled when generating error report, with condition instance as
  an argument, and result will be inserted into error report as an
  error context.</blockquote>
<blockquote>Initial value: <tt>KUCHENNIK::KUCHENNIK-ERROR-CONTEXT</tt></blockquote>
<p><b>*error-report-pathname-defaults*</b>&nbsp;&nbsp;&nbsp;<i>variable</i></p>
<blockquote>Base pathname for error reports when written to file.

Defaults to "error" in *DEFAULT-PATHNAME-DEFAULTS*.</blockquote>
<blockquote>Initial value: <tt>#P"state/error"</tt></blockquote>
<p><b>*handler-package*</b>&nbsp;&nbsp;&nbsp;<i>variable</i></p>
<blockquote>Package, in which HANDLER-FUNCTION looks for handlers.

When NIL, *PACKAGE* is assumed, which is probably not what you want.</blockquote>
<blockquote>Initial value: <tt>NIL</tt></blockquote>
<p>(<b>cache-dao</b> dao)&nbsp;&nbsp;&nbsp;<i>function</i></p>
<blockquote>Manually add DAO to cache used by WITH-DAO-CACHE.

Returns DAO</blockquote><p><b>DIRTINESS-MIXIN</b></p>&nbsp;&nbsp;&nbsp;<i><font color="FF0000">undocumented</font></i></p>
<p><b>DIRTY-P</b></p>&nbsp;&nbsp;&nbsp;<i><font color="FF0000">undocumented</font></i></p>
<p>(<b>execute*</b> statements &optional query-log)&nbsp;&nbsp;&nbsp;<i>function</i></p>
<blockquote>Execute a possibly nested list of sql STATEMENTS.

STATEMENTS may be either S-SQL expressions, literal SQL strings, or
lists of statements.</blockquote><p><b>FORMAT-ERROR-REPORT</b></p>&nbsp;&nbsp;&nbsp;<i><font color="FF0000">undocumented</font></i></p>
<p>(<b>handler-function</b> &rest name-parts)&nbsp;&nbsp;&nbsp;<i>function</i></p>
<blockquote>Return handler function whose name consists of NAME-PARTS.

Handler function name is NAME-PARTS joined with slash signes, and
starting with a slash; NIL part means an empty place.  E.g. for
NAME-PARTS :FOO :BAR :BAZ, it's /FOO/BAR/BAZ; for :FOO NIL it's /FOO/;
and for NIL :XYZZY it's //XYZZY.

If symbol with such name exists in *HANDLER-PACKAGE* (or in *PACKAGE*,
if *HANDLER-PACKAGE* is NIL, but probably it's not what you want), and
it names a function, this function is returned.</blockquote><p>(<b>hex-md5</b> sequence)&nbsp;&nbsp;&nbsp;<i>function</i></p>
<blockquote>Return MD5 checksum of SEQUENCE as a hexadecimal string.</blockquote><p>(<b>id</b> x)&nbsp;&nbsp;&nbsp;<i>generic-function</i></p>
<blockquote>Numeric ID or :NULL for DAOs and, if it makes sense, other objects.

Usually it will be a reader method automatically defined for ID column of a DAO.</blockquote><p>(<b>init-config</b> &rest files)&nbsp;&nbsp;&nbsp;<i>function</i></p>
<blockquote>Read in the configuration from files, defaulting to ones listed in *CONFIG-FILES*.

Should be first thing called in final init routine.</blockquote><p>(<b>init-db-connection</b> &optional section-name connect-toplevel-p)&nbsp;&nbsp;&nbsp;<i>function</i></p>
<blockquote>Initialize database connection from config.ini</blockquote><p>(<b>invoke-sendmail</b> sender rcpt body-and-headers &key sendmail-binary)&nbsp;&nbsp;&nbsp;<i>function</i></p>
<blockquote>Invoke sendmail binary.

SENDER is envelope sender address, RCPT is envelope recipient
address (may be a list), BODY-AND-HEADERS is fed to sendmail binary as
stdin and it may be a string or an input stream.  SENDMAIL-BINARY is
full path to sendmail binary, as a string, default is taken from
*CONFIG* section mailing, variable sendmail.</blockquote><p>(<b>make-keyword</b> str)&nbsp;&nbsp;&nbsp;<i>function</i></p>
<blockquote>Convert a string or symbol to a keyword.</blockquote><p><b>MARK-AS-DIRTY</b></p>&nbsp;&nbsp;&nbsp;<i><font color="FF0000">undocumented</font></i></p>
<p>(<b>named-lambda</b> name args &body body)&nbsp;&nbsp;&nbsp;<i>function</i></p>
<blockquote>Version of LAMBDA that returns anonymous function defined with
FLET and named NAME, which it's PRINTed with a name in most Lisp
implementations.</blockquote><p>(<b>null-or</b> v)&nbsp;&nbsp;&nbsp;<i>function</i></p>
<blockquote>If V is NIL or an empty string, return :NULL, otherwise return V.</blockquote><p>(<b>qp-utf8</b> string)&nbsp;&nbsp;&nbsp;<i>function</i></p>
<blockquote>Encode STRING as quoted-printable UTF-8</blockquote><p>(<b>random-string</b> &key alphabet min-length max-length)&nbsp;&nbsp;&nbsp;<i>function</i></p>
<blockquote>Simple random string for initial password to use in account activation process.</blockquote><p><b>REPORT-ERROR</b></p>&nbsp;&nbsp;&nbsp;<i><font color="FF0000">undocumented</font></i></p>
<p><b>REPORT-ERROR-BY-EMAIL</b></p>&nbsp;&nbsp;&nbsp;<i><font color="FF0000">undocumented</font></i></p>
<p><b>REPORT-ERROR-TO-FILE</b></p>&nbsp;&nbsp;&nbsp;<i><font color="FF0000">undocumented</font></i></p>
<p>(<b>salted-password</b> salt password)&nbsp;&nbsp;&nbsp;<i>function</i></p>
<blockquote>Return Base64-encoded MD5 checksum of SALT concatenated with PASSWORD.</blockquote><p>(<b>slug</b> x)&nbsp;&nbsp;&nbsp;<i>generic-function</i></p>
<blockquote>Get short, unique, urlified name of OBJECT.</blockquote><p>(<b>slug-dao</b> class slug)&nbsp;&nbsp;&nbsp;<i>function</i></p>
<blockquote>Select DAO of CLASS having "slug" column set to SLUG.</blockquote><p><b>SLUGIFY</b></p>&nbsp;&nbsp;&nbsp;<i><font color="FF0000">undocumented</font></i></p>
<p><b>START-HUNCHENTOOT</b></p>&nbsp;&nbsp;&nbsp;<i><font color="FF0000">undocumented</font></i></p>
<p>(<b>unless-null</b> v)&nbsp;&nbsp;&nbsp;<i>function</i></p>
<blockquote>If V equals :NULL, return NIL, otherwise return V.</blockquote><p><b>UPDATE-DAO-IF-DIRTY</b></p>&nbsp;&nbsp;&nbsp;<i><font color="FF0000">undocumented</font></i></p>
<p>(<b>with-dao-cache</b> &body body)&nbsp;&nbsp;&nbsp;<i>function</i></p>
<blockquote>Cache DAOs within dynamic extent of BODY.

Within BODY, DAO objects obtained by GET-DAO are cached to avoid
repeated queries fot the same objects.  DAO objects are added
automatically before being returned by GET-DAO, or can be added
manually with CACHE-DAO (e.g. when obtained by QUERY-DAO).</blockquote><font size=-1><p>Documentation generated by <a href="http://homepage.mac.com/svc/lispdoc/">lispdoc</a> running on Clozure Common Lisp</p></font></body></html>